%define major 3
%define libname %mklibname %{name} %{major}
%define develname %mklibname %{name} -d
%define ff_epoch 0
#define _prel rc3
%define realver %{major}.0.1
#define fullver %{realver}%{_prel}
# (tpg) MOZILLA_FIVE_HOME
%define mozillalibdir %{_libdir}/%{name}-%{realver}

Summary:	Next generation web browser
Name:		firefox
Version:	%{realver}
Epoch:		%{ff_epoch}
Release:	%mkrel 1
License:	MPLv1+
Group:		Networking/WWW
Url:		http://www.mozilla.org/
Source0:	ftp://ftp.mozilla.org/pub/mozilla.org/%{name}/releases/%{realver}/source/%{name}-%{realver}-source.tar.bz2
Source1:	%{SOURCE0}.asc
Source3:	%{name}.png
Source4:	%{name}.desktop
Source5:	firefox-searchengines-jamendo.xml
Source6:	firefox-searchengines-exalead.xml
Source7:	firefox-rebuild-databases.pl.in.generatechrome
Source8:	firefox-searchengines-askcom.xml
Patch0:		firefox-3.0rc1-pluginsdir.patch
Patch1:		mozilla-firefox-1.0-lang.patch
Patch2:		mozilla-firefox-1.5-vendor.patch
Patch3:		mozilla-firefox-1.5.0.6-systemproxy.patch
Patch4:		firefox-3.0b3-homepage.patch
Patch5:		firefox-3.0b3-check-default-browser.patch
Patch6:		mozilla-firefox-run-mozilla.patch
Patch8:		firefox-3.0rc1-glibc28-max_path-fix.patch
Patch9:		firefox-3.0rc1-no-WConversion.patch
#(tpg) use system-wide libIDL
Patch10:	firefox-3.0rc1-idldir.patch
Patch11:	firefox-3.0rc1-use-system-hunspell.patch
# (tpg) https://bugzilla.novell.com/show_bug.cgi?id=396552
Patch13:	firefox-3.0-correct-restart-command.patch
BuildRequires:	gtk+2-devel
BuildRequires:	libx11-devel
BuildRequires:	unzip
BuildRequires:	zip
#(tpg) older versions doesn't support apng extension
BuildRequires:	libpng-devel >= 1.2.25-2
BuildRequires:	libjpeg-devel
BuildRequires:	zlib-devel
BuildRequires:	libcairo-devel
BuildRequires:	glib2-devel
BuildRequires:	libIDL2-devel
BuildRequires:	makedepend
#(tpg) don't use system nss and nspr as they are not updated to latest version which supports ff3
#BuildRequires:	nss-devel
#BuildRequires:	nspr-devel
BuildRequires:	startup-notification-devel
BuildRequires:	dbus-glib-devel
BuildRequires:	lcms-devel
BuildRequires:	python-devel
# (fhimpe) Starting from Firefox 3.0.1, at least sqlite 3.5.9 is needed
# so only use system sqlite on Mandriva >= 2009.0
%if %mdkversion >= 200900
BuildRequires:	libsqlite3-devel >= 3.5.9
%endif
BuildRequires:	valgrind
BuildRequires:	rootcerts
BuildRequires:	libxt-devel
BuildRequires:	hunspell-devel
BuildRequires:	doxygen
BuildRequires:	libgnome-vfs2-devel
BuildRequires:	libgnome2-devel
BuildRequires:	libgnomeui2-devel
BuildRequires:	java-rpmbuild
Provides:	webclient
Requires:	indexhtml
Requires:       xdg-utils
Requires:	myspell-en_GB
Requires:	myspell-en_US
Requires(post):	desktop-file-utils
Requires(postun):	desktop-file-utils
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot
Requires:	%{libname} = %{ff_epoch}:%{version}-%{release}
# fixes bug #42096
Requires:	mailcap

%description
The award-winning Web browser is now faster, more secure, and fully customizable 
to your online life. With Firefox(R) 3, we've added powerful new features that 
make your online experience even better. It is an 'open source' product which is 
freely available, and is acquiring a growing proportion of international web 
browser usage.

Firefox claims to offer a more secure web browsing experience than other products, 
with better protection against spyware and other Internet-based security threats. 
It includes all the standard features of a modern web browser, like Internet 
searching, tracking recently visited sites, setting up shortcuts to favourite 
sites, customising the software behaviour and so on. Firefox also includes 
features like 'tabbed browsing' (opening several web sites as sections within the 
same window) and methods for controlling pop-up windows, cookies and downloaded 
files.

%package -n %{libname}
Summary:	Dynamic libraries for %{name}
Group:		System/Libraries

%description -n %{libname}
Dynamic libraries for %{name}.

%package -n %{develname}
Summary:	Development files for %{name}
Group:		Development/Other
Requires:	%{libname} = %{version}-%{release}

%description -n %{develname}
Development files for %{name}.

%prep
%setup -qn mozilla
%patch0 -p1 -b .plugins
%patch1 -p1 -b .lang
%patch2 -p1 -b .vendor
# Temporary disabled. It prevents firefox from running. 
#%patch3 -p1
%patch4 -p1 -b .homepage
%patch5 -p1 -b .defaultbrowser
# It was disabled because firefox3 hangs when using soundwrapper
#%patch6 -p1
# (tpg) fix MAXPATHLEN lenght for glibc-2.8
%patch8 -p1 -b .maxpath
# (tpg) gcc please stfu
%patch9 -p1 -b .stfu
%patch10 -p1 -b .idl
%patch11 -p1 -b .hun
%patch13 -p1 -b .restart

# (tpg) remove ff bookmarks, to use mdv ones
rm -rf browser/locales/en-US/profile/bookmarks.html
touch browser/locales/en-US/profile/bookmarks.html

# needed to regenerate certdata.c
pushd security/nss/lib/ckfw/builtins
perl ./certdata.perl < /etc/pki/tls/mozilla/certdata.txt
popd

%build
%serverbuild
export PREFIX="%{_prefix}"
export LIBDIR="%{_libdir}"
export CFLAGS="%{optflags}"
export CXXFLAGS="$CFLAGS"

# (tpg) don't use macro here
./configure \
	--prefix=%{_prefix} \
	--bindir=%{_bindir} \
	--libdir=%{_libdir} \
	--includedir=%{_includedir} \
	--datadir=%{_datadir} \
	--disable-ldap \
	--disable-calendar \
	--disable-mailnews \
	--disable-chatzilla \
	--disable-composer \
	--disable-profilesharing \
	--disable-toolkit-qt \
	--disable-installer \
	--disable-updater \
	--disable-debug \
	--disable-pedantic \
	--disable-native-uconv \
	--disable-elf-dynstr-gc \
	--disable-crashreporter \
	--disable-strip \
	--enable-crypto \
	--enable-places \
	--enable-storage \
	--enable-default-toolkit=cairo-gtk2 \
	--enable-official-branding \
	--enable-svg \
	--enable-svg-renderer=cairo \
	--enable-application=browser \
	--enable-single-profile \
	--enable-startup-notification \
	--enable-system-cairo \
	--enable-system-lcms \
	--enable-reorder \
	--enable-optimize \
	--enable-safe-browsing \
	--enable-xinerama \
	--enable-canvas \
	--enable-pango \
	--enable-xft \
	--enable-image-encoder=all \
	--enable-extensions=default \
	--enable-necko-protocols=all \
	--enable-necko-small-buffers \
	--enable-system-hunspell \
	--enable-install-strip \
	--enable-url-classifier \
	--with-distribution-id=com.mandriva \
	--with-system-zlib \
	--with-system-jpeg \
	--with-system-png \
	--with-pthreads \
	--with-valgrind \
	--enable-jemalloc \
	--enable-javaxpcom \
	--without-system-nspr \
	--without-system-nss \
%if %mdkversion >= 200900
	--enable-system-sqlite \
%else
	--disable-system-sqlite \
%endif
	--with-java-include-path=%{java_home}/include \
	--with-java-bin-path=%{java_home}/bin \
	--with-default-mozilla-five-home="%{mozillalibdir}"

%__perl -p -i -e 's|\-0|\-9|g' config/make-jars.pl

# (tpg) looks like it is working
sed -i -e 's#MDV_MOZPLUGIN_DIR#"%{_libdir}/mozilla/plugins"#g' xpcom/io/nsAppFileLocationProvider.cpp

%make

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%makeinstall_std

mkdir -p %{buildroot}%{_datadir}/{pixmaps,applications}

install -m 644 %{SOURCE3} %{buildroot}%{_datadir}/pixmaps/%{name}3.png
install -m 644 %{SOURCE4} %{buildroot}%{_datadir}/applications/%{name}3.desktop
mv %{buildroot}%{_bindir}/%{name} %{buildroot}%{_bindir}/%{name}3
sed -i "s,@LIBDIR@,%{_libdir}," %{buildroot}%{mozillalibdir}/%{name}

# create file allowing identification of distribution
cat << EOF > %{buildroot}%{mozillalibdir}/defaults/pref/vendor.js
pref("general.useragent.vendor", "Mandriva");
pref("general.useragent.vendorSub", "%{version}-%{release}");
pref("general.useragent.vendorComment", "%{mandriva_release}");
pref("mousewheel.horizscroll.withnokey.action", 0);
pref("mousewheel.horizscroll.withnokey.numlines", -1);
pref("mousewheel.horizscroll.withnokey.sysnumlines", true);
pref("network.protocol-handler.app.mailto", "/usr/bin/xdg-email");
pref("network.protocol-handler.app.mms", "/usr/bin/xdg-open");
pref("browser.display.use_system_colors", true);
pref("general.smoothScroll", true);
pref("browser.startup.homepage_override.mstone", "ignore");
pref("print.print_edge_top", 14); // 1/100 of an inch
pref("print.print_edge_left", 16); // 1/100 of an inch
pref("print.print_edge_right", 16); // 1/100 of an inch
pref("print.print_edge_bottom", 14); // 1/100 of an inch
pref("browser.backspace_action", 2);
pref("browser.tabs.loadFolderAndReplace", false);
pref("browser.EULA.override", true);
pref("browser.safebrowsing.enabled", true);
pref("app.update.enabled", false);
pref("app.update.auto", false);
pref("network.http.pipelining", true);
pref("browser.tabs.loadDivertedInBackground", true);
EOF

cat << EOF >> %{buildroot}%{mozillalibdir}/defaults/profile/prefs.js
user_pref("browser.search.selectedEngine","Ask.com");
user_pref("browser.search.order.1","Ask.com");
user_pref("browser.search.order.2","Exalead");
user_pref("browser.search.order.3","Google");
user_pref("browser.search.order.4","Yahoo");
EOF

# search engines
cp -f %{SOURCE5} %{buildroot}%{mozillalibdir}/searchplugins/jamendo.xml
cp -f %{SOURCE6} %{buildroot}%{mozillalibdir}/searchplugins/exalead.xml
cp -f %{SOURCE8} %{buildroot}%{mozillalibdir}/searchplugins/askcom.xml

%if %mdkversion == 200900
sed -i 's/@DISTRO_VALUE@/101490/' %{buildroot}%{mozillalibdir}/searchplugins/askcom.xml
sed -i 's/@DISTRO_VALUE@/MDV20090/' %{buildroot}%{mozillalibdir}/searchplugins/exalead.xml
%else
%if %mdkversion == 200810
sed -i 's/@DISTRO_VALUE@/1681/' %{buildroot}%{mozillalibdir}/searchplugins/askcom.xml
sed -i 's/@DISTRO_VALUE@/MDV20081/' %{buildroot}%{mozillalibdir}/searchplugins/exalead.xml
%else
%if %mdkversion == 200800
sed -i 's/@DISTRO_VALUE@/1680/' %{buildroot}%{mozillalibdir}/searchplugins/askcom.xml
sed -i 's/@DISTRO_VALUE@/MDV20080/' %{buildroot}%{mozillalibdir}/searchplugins/exalead.xml
%else
%if %mdkversion == 200710
sed -i 's/@DISTRO_VALUE@/1655/' %{buildroot}%{mozillalibdir}/searchplugins/askcom.xml
sed -i 's/@DISTRO_VALUE@/MDV20071/' %{buildroot}%{mozillalibdir}/searchplugins/exalead.xml
%else
%if %mdkversion == 200700
sed -i 's/@DISTRO_VALUE@/101489/' %{buildroot}%{mozillalibdir}/searchplugins/askcom.xml
sed -i 's/@DISTRO_VALUE@/MDV20070/' %{buildroot}%{mozillalibdir}/searchplugins/exalead.xml
%else
%if %mdkversion == 300
sed -i 's/@DISTRO_VALUE@/101471/' %{buildroot}%{mozillalibdir}/searchplugins/askcom.xml
sed -i 's/@DISTRO_VALUE@/MDVCorp/' %{buildroot}%{mozillalibdir}/searchplugins/exalead.xml
%else
# default
sed -i 's/@DISTRO_VALUE@/ffx/' %{buildroot}%{mozillalibdir}/searchplugins/askcom.xml
sed -i 's/@DISTRO_VALUE@//' %{buildroot}%{mozillalibdir}/searchplugins/exalead.xml
%endif #corp
%endif #200700
%endif #200710
%endif #200800
%endif #200810
%endif #200900

#ghost files
touch %{buildroot}%{mozillalibdir}/components/compreg.dat
touch %{buildroot}%{mozillalibdir}/components/xpti.dat

# firefox update tool
cat %{SOURCE7} |\
    sed -e "s|FIREFOX_VERSION|%{realver}|g;s|LIBDIR|%{_libdir}|g"\
    > %{buildroot}%{mozillalibdir}/firefox-rebuild-databases.pl
chmod 755 %{buildroot}%{mozillalibdir}/firefox-rebuild-databases.pl

%find_lang %{name}

%if %mdkversion < 200900
%post
%{update_menus}
%{update_desktop_database}
%endif

%if %mdkversion < 200900
%postun
%{clean_menus}
%{clean_desktop_database}
%endif

%post -n %{libname}
unset DISPLAY
%{mozillalibdir}/firefox-rebuild-databases.pl
if [ ! -r /etc/sysconfig/oem ]; then
  case `grep META_CLASS /etc/sysconfig/system` in
    *powerpack) bookmark="mozilla-powerpack.html" ;;
    *desktop) bookmark="mozilla-one.html";;
    *) bookmark="mozilla-download.html";;
  esac
  ln -s -f ../../../../share/mdk/bookmarks/mozilla/$bookmark  %{mozillalibdir}/defaults/profile/bookmarks.html
fi

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files -f %{name}.lang
%defattr(-,root,root)
%{_bindir}/%{name}3
%{_datadir}/pixmaps/*.png
%ghost %{mozillalibdir}/components/compreg.dat
%ghost %{mozillalibdir}/components/xpti.dat
%{_datadir}/applications/*.desktop

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/%{name}-%{realver}*

%files -n %{develname}
%defattr(-,root,root)
%{_includedir}/%{name}*
%{_libdir}/%{name}-devel-%{realver}*


%changelog
* Thu Jul 24 2008 Funda Wang <fundawang@mandriva.org> 0:3.0.1-1mdv2008.1
+ Revision: 245001
- use internal sqlite for previous releases

  + Frederik Himpe <fhimpe@mandriva.org>
    - Starting from Firefox 3.0.1, at least sqlite 3.5.9 is needed, so on
      Mandriva older than 2009.0 use the included sqlite library instead
      of the system wide one

* Mon Jul 21 2008 Tiago Salem <salem@mandriva.com.br> 0:3.0.1-1mdv2009.0
+ Revision: 239495
- Remove networkmanager and sqlite pacthes as they are upstream now.
- add Requires to mailcap. Fixes bug #42096
- add ask.com search engine
- change search engines menu order
- bump release
- Changing old firefox 2 description to a new one.
- bump release (0.b5.2mdv)
- fixing libdir for plugins
- renaming startup script to firefox3
- adding Requires to libfirefox3 on firefox3 package
- changing desktop file to point to firefox3
- fix wrong plugins directory.
- Disabling broken patches.

  + Tomasz Pawel Gajc <tpg@mandriva.org>
    - no more branches, move firefox to its own svn place
    - update to new version 3.0.1
    - do not strip debug symbols so the debug package is not empty
    - Patch13: use the correct restart command for session managers (plugins are not being loaded after user login)
    - try to use jemalloc instead of malloc, as it can help reduce memory fragmentation
    - enable java build, add buildrequires on java-rpmbuild
    - provide better description
    - let's try compile firefox with enabled strict aliasing
    - don't pass our %%optflags for --enable-optimize
    - Patch12: ignore NetworkManager status (upstream mozilla bug #424626)
    - update to new release 3.0
    - update to new release candidate rc3
    - update to new release candidate rc2
    - add missing build requires on gnome stuff (handle mime-types #41201)
    - add build requires on doxygen
    - do not install buildrequires for nss-devel and nspr-devel because ff3 uses its own (for now)
    - hunspell handles now dictionaries, no need to create a symlinks for them
    - set pref browser.tabs.loadDivertedInBackground (more infos at bug #25009)
    - disable crashreporter, and drop buildrequires on curl-devel
    - fix file list
    - Patch0: try better solution of get the mozilla plugins path (work in progress)
    - Patch10: do not use firefox's own libIDL
    - Patch11: hopefully fix compiling against system-wide hunspell
    - do not build crashreporter tool
    - enable all image encoders
    - enable default extensions
    - enable hunspell support (it is in main now)
    - use %%serverbuild macro
    - add cache files
    - disable hunspell because it is in contrib :(
    - enable system-wide hunspell support
    - use system-wide dictionaries
    - requires desktop-file-utils
    - drop patch 10, set preferences into spec file
    - add search engines
    - add firefox-rebuild-databases.pl tool
    - enable Mandriva specific bookmarks
    - add Mandriva specific settings
    - disable EULA popup
    - regenerate certificates
    - disable native uconv (really fixes #40944)
    - re-enable Xft support
    - drop requires on icu and buildrequires on icu-devel (useless)
    - Patch10: various firefox preferences
      o disable firefox update
      o enable smooth scroll
      o use system colors
      o enable http pipelining
    - add buildrequires on icu-devel (#40944)
    - Patch8: completely re-done patch, get the MAXPATHLEN from glibc rather than hardcoding (fixes buffer overflow #41102)
    - Patch9: remove -WConversion, this silences gcc output
    - Patch8: fix exePath lenght to prevent firefox crash
    - disable Xft as it sometimes renders bad fonts (# 40944)
    - don not ise system-wide nspr and nss libraries, because they were not updated yet
    - fix file list
    - fix desktop file
    - drop the mozilla prefix from the name
    - enable sqlite support
    - new version
    - backport few patches from firefox2
    - add source and spec file

  + Giuseppe Ghibò <ghibo@mandriva.com>
    - Versioning sqlite BuildRequires.
    - Don't force expanded %%{optflags} in CFLAGS.

  + Thierry Vignaud <tvignaud@mandriva.com>
    - devel package needs the library
    - fix 'empty-%%post(|un)' error (rpm filetriggers deprecates update_menus &
      update_desktop_database)
    - stop packaging useless OS/2 & build doc as well as CVS directories
    - RC1
    - patch 7: fix testing for sqlite >= 3.5.4 that fails with sqlite-3.5.7

